DECLARE SUB ConvDate (TempDate$, DateTemp$)

REM DATEFIND.BAS
REM Written by Saul G. Levy, Tucson, Arizona, 5/13/93
REM Last changed 5/16/93

REM Finds date strings within text files which match a range of dates.
REM The whole line of text is displayed on a match

REM Get input parameters

COLOR 15, 1
CLS
PRINT "DATEFIND.BAS"
PRINT : PRINT
PRINT "Finds dates in text files which match a range of dates."
PRINT "Dates are in MM-DD-YY format only (the default ending date is in 2079)!"
PRINT "Note that dates are not tested for accuracy in any way!"
PRINT
INPUT "Enter INPUT  file name: ", FileName$
INPUT "Enter OUTPUT file name (if wanted): ", OutFile$
PRINT
INPUT "Enter STARTING COLUMN where date starts (1 to n): ", StartCol
PRINT
INPUT "Enter STARTING DATE (MM-DD-YY): ", StartDate$

REM Convert date to YYYYMMDD format
TempDate$ = StartDate$
CALL ConvDate(TempDate$, DateTemp$)
DateStart$ = DateTemp$

INPUT "Enter ENDING DATE (ENTER=12-31-79): ", EndDate$
IF EndDate$ = "" THEN EndDate$ = "12-31-79"

TempDate$ = EndDate$
CALL ConvDate(TempDate$, DateTemp$)
DateEnd$ = DateTemp$

REM Open files

OPEN "I", #1, FileName$
OutFlag = 0: REM Output flag
IF OutFile$ <> "" THEN OPEN "O", #2, OutFile$: OutFlag = 1
PRINT "DATEFIND is working..."
EOFFlag = 0: REM End-of-File flag (makes sure the last line in the
             REM input file will be processed)

DoAnother:

REM Read each line of text from input file
LINE INPUT #1, Text$
IF EOF(1) THEN EOFFlag = 1

REM Line too short to have a date?
IF LEN(Text$) < StartCol GOTO DoAnother

REM Convert date from input file
TempDate$ = MID$(Text$, StartCol, 8)
CALL ConvDate(TempDate$, DateTemp$)
TestDate$ = DateTemp$

REM Test date for a match
IF TestDate$ < DateStart$ THEN GOTO EOFCheck
IF TestDate$ > DateEnd$ THEN GOTO EOFCheck

REM Output text if there was a match
PRINT Text$
IF OutFlag = 1 THEN PRINT #2, Text$

EOFCheck:

IF EOFFlag = 0 THEN GOTO DoAnother

Finished:

PRINT "DATEFIND is finished!"
CLOSE

END

SUB ConvDate (TempDate$, DateTemp$)

Year$ = RIGHT$(TempDate$, 2)

REM Convert date to 19yy or 20yy format
IF Year$ >= "80" AND Year$ <= "99" THEN
  DateTemp$ = "19"
ELSE
  DateTemp$ = "20"
END IF

DateTemp$ = DateTemp$ + Year$ + LEFT$(TempDate$, 2) + MID$(TempDate$, 4, 2)

END SUB
